HilbertBasecase Class Reference

`#include <HilbertBasecase.h>`

## Classes

struct | Entry

## Public Member Functions

| HilbertBasecase ()
| ~HilbertBasecase ()
void | computeCoefficient (Ideal &ideal)
const mpz_class & | getLastCoefficient ()

## Private Member Functions

void | clearTodo ()
bool | stepComputation (Entry &entry, Entry &newEntry)
unique_ptr< Ideal > | getNewIdeal ()
void | freeIdeal (unique_ptr< Ideal > ideal)
bool | canSimplify (size_t var, const Ideal &ideal, const Term &counts)
size_t | eliminate1Counts (Ideal &ideal, Term &counts, bool &negate)

## Private Attributes

vector< Entry > | _todo
vector< Ideal * > | _idealCache
ElementDeleter< vector< Ideal * > > | _idealCacheDeleter
mpz_class | _sum
Term | _term
size_t | _stepsPerformed

## Detailed Description

Definition at line 27 of file HilbertBasecase.h.

## Constructor & Destructor Documentation

## HilbertBasecase()

HilbertBasecase::HilbertBasecase | ( |  | ) |

Definition at line 24 of file HilbertBasecase.cpp.

## ~HilbertBasecase()

HilbertBasecase::~HilbertBasecase | ( |  | ) |

Definition at line 29 of file HilbertBasecase.cpp.

## Member Function Documentation

## canSimplify()

bool HilbertBasecase::canSimplify | ( | size_t | var,
|  | const Ideal & | ideal,
|  | const Term & | counts )

private

Definition at line 194 of file HilbertBasecase.cpp.

## clearTodo()

void HilbertBasecase::clearTodo | ( |  | ) |

private

## computeCoefficient()

void HilbertBasecase::computeCoefficient | ( | Ideal & | ideal | ) |

Definition at line 131 of file HilbertBasecase.cpp.

## eliminate1Counts()

size_t HilbertBasecase::eliminate1Counts | ( | Ideal & | ideal,
|  | Term & | counts,
|  | bool & | negate )

private

Definition at line 223 of file HilbertBasecase.cpp.

## freeIdeal()

void HilbertBasecase::freeIdeal | ( | unique_ptr< Ideal > | ideal | ) |

private

Definition at line 285 of file HilbertBasecase.cpp.

## getLastCoefficient()

const mpz_class & HilbertBasecase::getLastCoefficient | ( |  | ) |

Definition at line 190 of file HilbertBasecase.cpp.

## getNewIdeal()

unique_ptr< Ideal > HilbertBasecase::getNewIdeal | ( |  | ) |

private

Definition at line 275 of file HilbertBasecase.cpp.

## stepComputation()

bool HilbertBasecase::stepComputation | ( | Entry & | entry,
|  | Entry & | newEntry )

private

Definition at line 42 of file HilbertBasecase.cpp.

## Member Data Documentation

## _idealCache

vector<Ideal*> HilbertBasecase::_idealCache

private

Definition at line 50 of file HilbertBasecase.h.

## _idealCacheDeleter

ElementDeleter<vector<Ideal*> > HilbertBasecase::_idealCacheDeleter

private

Definition at line 51 of file HilbertBasecase.h.

## _stepsPerformed

size_t HilbertBasecase::_stepsPerformed

private

Definition at line 58 of file HilbertBasecase.h.

## _sum

mpz_class HilbertBasecase::_sum

private

Definition at line 56 of file HilbertBasecase.h.

## _term

Term HilbertBasecase::_term

private

Definition at line 57 of file HilbertBasecase.h.

## _todo

vector<Entry> HilbertBasecase::_todo

private

Definition at line 43 of file HilbertBasecase.h.

The documentation for this class was generated from the following files:

- src/HilbertBasecase.h
- src/HilbertBasecase.cpp